local elapsedTime = 0.0
local splittingInProgress = false
local itemStackAmount			
local Bagpack={}; 
local bagSlotIdForItem
local lastCreatedStack = 0
local split_count = 1
local quickSplitCount = 1
local itemsToSplit = {}

local function Splitter_ClearAll()

	elapsedTime = 0.0
	splittingInProgress = false
	itemStackAmount = nil
	Bagpack={}; 
	bagSlotIdForItem = nill
	lastCreatedStack = 0
	split_count = 1
	itemsToSplit = {}
end

function Splitter_OnUpdate(_elapsedTime)
	elapsedTime = elapsedTime + _elapsedTime;

	if splittingInProgress and elapsedTime > 0.3 then
	
		elapsedTime = 0
		
		Splitter_SplitAndPickupItem()
		
		if lastCreatedStack == (tonumber(itemStackAmount)) then
			splittingInProgress = false
		end
	end
end

function Splitter_GetBagpack()
	Splitter_ClearAll()
	local splitChanged = false
	local itemName = _G["Splitter_MainFrame_Item1_EditBox"]:GetText()
	itemStackAmount = _G["Splitter_MainFrame_Item2_EditBox"]:GetText()
	split_count = _G["Splitter_MainFrame_Item3_EditBox"]:GetText()
	
	local _, totalBagSlots = GetBagCount()
	for i=1, totalBagSlots do
		
		local bagid, texture, name, itemCount, locked, invalid = GetBagItemInfo(i)
		if name == itemName then
			
			if itemCount < itemStackAmount*split_count then
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Item splitter: Not enough "..name.." in your bag. "..tostring(itemStackAmount*split_count).." needed but only got "..tostring(itemCount))
				return
			end
			
			if itemCount == itemStackAmount*split_count and not splitChanged then
				-- use one more stack, because if size is exactly the needed one, the last stack wouldn't be created
				
				splitChanged = true
				lastCreatedStack = lastCreatedStack + 1
				table.insert(itemsToSplit, i)
			end
			
			bagSlotIdForItem = i
			
		elseif itemCount == 0 then
			Bagpack[i] = i
		end
	end
	
	if bagSlotIdForItem == nil then
		return
	end
	
	splittingInProgress = true 
end

SLASH_SPLIT1 = "/split"
SlashCmdList["SPLIT"] = function(_, args)
	if ( args:match("%d+") ) then
			quickSplitCount = tonumber(args)
			DEFAULT_CHAT_FRAME:AddMessage("Quick split is now set to |cffffffff" .. quickSplitCount .. "|r")
		else
			Splitter_MainFrame:Show()
		end
end

local function FindEmptyBagSlot()
	local _, totalBagSlots = GetBagCount()
	for i = 1, totalBagSlots do
		local bagIndex, iconFile, name, itemCount = GetBagItemInfo(i)
		if (not iconFile or iconFile == "") and itemCount == 0 then
			table.insert(itemsToSplit, i)
			return bagIndex
		end
	end
end

function Splitter_SplitAndPickupItem()
	local emptySlot =	FindEmptyBagSlot()
	local bagId = GetBagItemInfo(bagSlotIdForItem)
	SplitBagItem(bagId, split_count)
	PickupBagItem(emptySlot) -- put item in empty bag slot
	
	lastCreatedStack = lastCreatedStack + 1
end

local alreadyHooked = false

function Splitter_BagItemButton_OnClick(this, button, ignoreShift)
	if (IsShiftKeyDown() and _G["Splitter_MainFrame"]:IsVisible() ) then
		local _, _, name = GetBagItemInfo(this:GetID())

		_G["Splitter_MainFrame_Item1_EditBox"]:SetText(name)
		_G["Splitter_MainFrame_Item1_EditBox"]:SetFocus()
	elseif ( IsCtrlKeyDown() and IsShiftKeyDown() and not _G["Splitter_MainFrame"]:IsVisible()) then
		local emptySlot = FindEmptyBagSlot()
		local _, _, _, itemCount = GetBagItemInfo(this:GetID())

		if emptySlot and itemCount > quickSplitCount then
			SplitBagItem(this.index, quickSplitCount)
			PickupBagItem(emptySlot) -- put item in empty bag slot
		end
	else
		assert(old_BagItemButton_OnClick ~= nil)
		old_BagItemButton_OnClick(this, button, ignoreShift)
	end
end

local function Splitter_CreateHook()
	if ( not alreadyHooked ) then
		if (type(yBagItem_OnClick) == "function") then
			old_BagItemButton_OnClick = yBagItem_OnClick
			yBagItem_OnClick = Splitter_BagItemButton_OnClick
		else
			old_BagItemButton_OnClick = BagItemButton_OnClick
			BagItemButton_OnClick = Splitter_BagItemButton_OnClick
		end
		alreadyHooked = true
	end
end

Splitter_CreateHook()